/******************************************************************************
 * $Id: src/debug.c, v0.01 17:32 27.11.2010 TiN Exp $
 *
 * Copyright (c) 2010, xDevs.com ARM Microcontroller Software Support
 *
 * Debug port routines / chip detect
 *
 * Project maintainers:
 *  o Tsemenko Ilya  (ilya@xdevs.com)
 *  o Alex Gurin     (warder@xdevs.com)
 */

#include <types.h>
#include <macros.h>
#include <arm/dbgu.h>
#include <arm/pio.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "debug.h"
#include "hc1.h"

#ifdef DEVEL_MODE

static uint8_t debug_level = 0;

void debug_init(void) {

    /* arm_pio_set_periphA(PIN_DBGU_RXD, ARM_PIO_DEFAULT); */ /* LCD SPI NPCS1 conflict */
    arm_pio_set_periphA(PIN_DBGU_TXD, ARM_PIO_DEFAULT);

    arm_dbgu_configure(DEBUG_STANDART, DEBUG_SPEED, MCK_SPEED);
}

int write_debug(uint8_t level, const char *format, ...)
{
    char    buf[DEBUG_BUF_SIZE];
    short   len, i;
    va_list vl;

    if (level < debug_level)
        return -1;

    va_start(vl, format);
    vsnprintf(buf, sizeof(buf), format, vl);
    va_end(vl);

    len = strlen(buf);

    for (i = 0; i < len; i++)
        arm_dbgu_putc(buf[i]);

    /* terminate line */
    arm_dbgu_putc('\n');
    arm_dbgu_putc('\r');

    return 0;
}

#endif /* DEVEL_MODE */
